# ChatPanel (vilya 1.3 API)
Date: 2011-04-06

## com.threerings.micasa.client
Class ChatPanel

    java.lang.Object
      java.awt.Component
          java.awt.Container
              javax.swing.JComponent
                  javax.swing.JPanel
                      com.threerings.micasa.client.ChatPanel

All Implemented Interfaces:
  com.threerings.crowd.chat.client.ChatDisplay, com.threerings.crowd.client.OccupantObserver, com.threerings.crowd.client.PlaceView, ActionListener, ImageObserver, MenuContainer, Serializable, EventListener, Accessible

    public class ChatPanel

extends JPanel
implements ActionListener, com.threerings.crowd.chat.client.ChatDisplay, com.threerings.crowd.client.OccupantObserver, com.threerings.crowd.client.PlaceView

See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class javax.swing.JComponent
`JComponent.AccessibleJComponent`

Nested classes/interfaces inherited from class java.awt.Component
`Component.BaselineResizeBehavior`

Field Summary

Fields inherited from class javax.swing.JComponent
`TOOL_TIP_TEXT_KEY, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`ChatPanel(com.threerings.crowd.util.CrowdContext ctx)`
`ChatPanel(com.threerings.crowd.util.CrowdContext ctx, boolean showHintLabel)`

Method Summary
`void` `actionPerformed(ActionEvent e)`
`void` `clear()`
`void` `didLeavePlace(com.threerings.crowd.data.PlaceObject place)`
`boolean` `displayMessage(com.threerings.crowd.chat.data.ChatMessage message, boolean displayed)`
`Dimension` `getPreferredSize()`
`void` `occupantEntered(com.threerings.crowd.data.OccupantInfo info)`
`void` `occupantLeft(com.threerings.crowd.data.OccupantInfo info)`
`void` `occupantUpdated(com.threerings.crowd.data.OccupantInfo oinfo, com.threerings.crowd.data.OccupantInfo info)`
`void` `removeSendButton()` For applications where the chat box has extremely limited space, the send button can be removed to leave more space for the text input box.
`void` `setRequestFocus(boolean focus)` Sets whether the chat box text entry field requests the keyboard focus when the panel receives `AncestorListener.ancestorAdded(javax.swing.event.AncestorEvent)` or `PlaceView.willEnterPlace(com.threerings.crowd.data.PlaceObject)` events.
`void` `willEnterPlace(com.threerings.crowd.data.PlaceObject place)`

Methods inherited from class javax.swing.JPanel
`getAccessibleContext, getUI, getUIClassID, setUI, updateUI`

Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintImmediately, paintImmediately, print, printAll, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusBackward, transferFocusDownCycle, validate`

Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, contains, createImage, createImage, createVolatileImage, createVolatileImage, dispatchEvent, enable, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusUpCycle`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ChatPanel

    public ChatPanel(com.threerings.crowd.util.CrowdContext ctx)

### ChatPanel

    public ChatPanel(com.threerings.crowd.util.CrowdContext ctx,
                     boolean showHintLabel)

Method Detail

### removeSendButton

    public void removeSendButton()

  For applications where the chat box has extremely limited space, the send button can be removed to leave more space for the text input box.

### setRequestFocus

    public void setRequestFocus(boolean focus)

  Sets whether the chat box text entry field requests the keyboard focus when the panel receives `AncestorListener.ancestorAdded(javax.swing.event.AncestorEvent)` or `PlaceView.willEnterPlace(com.threerings.crowd.data.PlaceObject)` events.

### actionPerformed

    public void actionPerformed(ActionEvent e)

  Specified by:
    `actionPerformed` in interface `ActionListener`

### occupantEntered

    public void occupantEntered(com.threerings.crowd.data.OccupantInfo info)

  Specified by:
    `occupantEntered` in interface `com.threerings.crowd.client.OccupantObserver`

### occupantLeft

    public void occupantLeft(com.threerings.crowd.data.OccupantInfo info)

  Specified by:
    `occupantLeft` in interface `com.threerings.crowd.client.OccupantObserver`

### occupantUpdated

    public void occupantUpdated(com.threerings.crowd.data.OccupantInfo oinfo,
                                com.threerings.crowd.data.OccupantInfo info)

  Specified by:
    `occupantUpdated` in interface `com.threerings.crowd.client.OccupantObserver`

### clear

    public void clear()

  Specified by:
    `clear` in interface `com.threerings.crowd.chat.client.ChatDisplay`

### displayMessage

    public boolean displayMessage(com.threerings.crowd.chat.data.ChatMessage message,
                                  boolean displayed)

  Specified by:
    `displayMessage` in interface `com.threerings.crowd.chat.client.ChatDisplay`

### willEnterPlace

    public void willEnterPlace(com.threerings.crowd.data.PlaceObject place)

  Specified by:
    `willEnterPlace` in interface `com.threerings.crowd.client.PlaceView`

### didLeavePlace

    public void didLeavePlace(com.threerings.crowd.data.PlaceObject place)

  Specified by:
    `didLeavePlace` in interface `com.threerings.crowd.client.PlaceView`

### getPreferredSize

    public Dimension getPreferredSize()

  Overrides:
    `getPreferredSize` in class `JComponent`

Copyright © 2011. All Rights Reserved.